VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSteel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_strName As String
Private m_colMuB As Collection
Private m_sTmax As Single

Private Sub Class_Initialize()
    Set m_colMuB = New Collection
End Sub

Public Property Let Name(ByVal strName As String)
    m_strName = strName
End Property

Public Property Get Name() As String
    Name = m_strName
End Property

Public Property Let Tmax(ByVal sValue As Single)
    m_sTmax = sValue
End Property

Public Property Get Tmax() As Single
    Tmax = m_sTmax
End Property

Public Property Get MuBs() As Collection
    Set MuBs = m_colMuB
End Property

Public Sub LoadFromFile(ByVal strFile As String)
Dim lStart As Long
Dim lEnd As Long
Dim ini As cINI
Dim strKeys() As String
Dim i As Long
Dim mub As cmub

    ' Load steel
    ' Extract name
    lStart = InStrRev(strFile, "\")
    lEnd = InStrRev(strFile, ".") - 1
    
    If lStart <= 0 Then
        lStart = 1
    End If
    
    If lEnd <= 0 Then
        lEnd = Len(strFile)
    End If
    
    m_strName = Mid$(strFile, lStart, lEnd)
    
    Set ini = New cINI
    ini.File = strFile
    
    m_sTmax = Val(ini.ReadString("GENERAL", "MaxB"))
    If m_sTmax = 0 Then m_sTmax = 1.25
    
    strKeys = ini.GetKeysInSection("PERM")
    Set m_colMuB = New Collection
    For i = 0 To UBound(strKeys)
        Set mub = New cmub
        mub.B = Val(strKeys(i))
        mub.Mu = Val(ini.ReadString("PERM", strKeys(i)))
        Call m_colMuB.Add(mub)
    Next

End Sub

Public Function Extrapol(X As Single) As Single
Dim fFirst As Boolean
Dim NX As Single
Dim PX As Single
Dim NY As Single
Dim PY As Single
Dim MubPrev As cmub
Dim mub As cmub

    fFirst = True
    For Each mub In m_colMuB
        If mub.B >= X Then  'Trouv ou trop loin
            NX = mub.B
            PX = NX
            NY = mub.Mu
            PY = NY
            If Not MubPrev Is Nothing Then     'Il y a un prcdent
                PX = MubPrev.B
                PY = MubPrev.Mu
            End If
            Extrapol = PY + ((NY - PY) / ((NX - PX) / (X - PX)))
            Exit Function   'Ca baigne !
        End If
        Set MubPrev = mub
    Next
    If Not mub Is Nothing Then
        Extrapol = mub.Mu 'X trop grand,on renvoie le plafond !
    End If
End Function

